#ifndef __APPLOG_HPP__
#define __APPLOG_HPP__

#include <math.h>

#define FP 16 //fixed point
#define SFP (1<<FP)

class appLog{
public:
	appLog(const uint _mapSize):mapSize(_mapSize),logMap(NULL){
		logMap = new uint [_mapSize];
		if (logMap==NULL){
			fprintf(stderr,"cannot allocate for logMap\n");
			throw;
		}

		logMap[0] = 0;
		for (uint i = 1; i < mapSize; i++){
			logMap[i] = (uint)(log((float)mapSize/i) / log(2.f) * SFP);
		}
	}
	~appLog(){
		if (logMap) delete[] logMap;
	}

	uint get(const uint numer ,const uint denomi) const{
		//return log(denomi/number);
		uint pos = numer*mapSize/denomi;
		if (pos > mapSize){
			printf("error in appLog::get() numer:%d denomi:%d pos:%d mapSize:%d\n",numer,denomi,pos,mapSize);
			return 0;
		}
		//printf("numer:%d denomi:%d app:%d log:%f\n",numer,denomi,logMap[numer*mapSize/denomi], log((float)denomi/numer)*SFP);
		
		return logMap[pos];
	}

private:
	uint* logMap;
	uint mapSize;
};

#endif //__APPLOG_HPP__