#ifndef __CANONICALENCODER_HPP_INCLUDED__
#define __CANONICALENCODER_HPP_INCLUDED__
#include "encoder.hpp"
#include "tableDecoder.hpp"


class canonicalEncoder : public encoder {
	private:
		std::map<unsigned long,unsigned long> patternCount;
		tableDecoder* decode;
		unsigned long length; //length of previously found code
		unsigned long predictedSize; //total length of encoded text in bits

	public:
		/** constructor
		* @warning a decoder object will be allocated that will not be destoyed by any function in this class. get a pointer to it via getDecoder() and take care of its destruction.
		*/
		canonicalEncoder();

		//inherited
		void include(unsigned long bitpattern);
		bool exclude(unsigned long bitpattern);
		void calcCode();
		unsigned long predictSize();
		unsigned long encode(unsigned long bitpattern);
		unsigned long getLength();
		decoder* getDecoder();
};

#endif
