#include "fibonacciEncoder.hpp"
#include "tableDecoder.hpp"
#include <algorithm>
#include <sdsl/bitmagic.hpp>

/*struct comparator {
	bool operator() (std::pair<unsigned long, unsigned long> i,std::pair<unsigned long, unsigned long> j) {
		return (i.second>j.second);
	}
};*/

fibonacciEncoder::fibonacciEncoder() {
	decode = new tableDecoder();
}

void fibonacciEncoder::include(unsigned long bitpattern) {
	patternCount[bitpattern]++;
}

bool fibonacciEncoder::exclude(unsigned long bitpattern) { return false;} //not yet implemented

void fibonacciEncoder::calcCode() {
/*	//convert hashmap to vector for sorting
	unsigned long maxLength = 0;
	std::vector<std::pair<unsigned long, unsigned long> > patternCountVector;
	patternCountVector.resize(patternCount.size());
	std::vector<std::pair<unsigned long, unsigned long> >::iterator vectIt = patternCountVector.begin();
	std::map<unsigned long, unsigned long>::iterator mapIt;
	for(mapIt = patternCount.begin(); mapIt != patternCount.end(); mapIt++) {
		unsigned long length = sdsl::bit_magic::l1BP(mapIt->first) + 1;
		maxLength = std::max(maxLength, length);
		*vectIt = *mapIt;
		vectIt++;
	}
	//sort
	std::sort(patternCountVector.begin(), patternCountVector.end(), comparator());
	decode->init(patternCountVector.size() + 1, maxLength);		//+ 1 is for the zero length encoding we do not want to use
	//convert vector back to hash and fill decoder
	predictedSize = 0;
	for(unsigned long i = 0; i < patternCountVector.size(); i++){
		unsigned long codeWithLength = i + 2;
		patternCount[patternCountVector[i].first] = codeWithLength;
		unsigned long length = sdsl::bit_magic::l1BP(codeWithLength);
		unsigned long codeWithoutLength = codeWithLength - (1 << length);
		predictedSize += length * patternCountVector[i].second;
		decode->add(codeWithoutLength, length, patternCountVector[i].first);
	}
*/}

unsigned long fibonacciEncoder::predictSize() {
	return predictedSize;
}

unsigned long fibonacciEncoder::encode(unsigned long bitpattern) {
/*	unsigned long ret = patternCount[bitpattern];
	length = sdsl::bit_magic::l1BP(ret);
	ret = ret - (1 << length);
	return ret;*/
}

unsigned long fibonacciEncoder::getLength() {
	return length;
}

decoder* fibonacciEncoder::getDecoder() {
	return decode;
}
