unsigned int dEbUg1 = 42;
unsigned int dEbUg2 = 42;
int dEbUg3 = 0;
#include "selectBitVector.hpp"
#include "Practical_ent_rs/combination.hpp"
#include "canonicalEncoder.hpp"

#include <sdsl/util.hpp>
#include <sdsl/bitmagic.hpp>
#include <sdsl/int_vector.hpp>
#include <sdsl/rank_support.hpp>
#include <sdsl/select_support_mcl.hpp>
#include <stdio.h>
#include <map>
#include <algorithm>

using namespace std;
using namespace sdsl;

const unsigned long firstKmasks[65] = {	0x00000000, 	0x0000000000000001, 0x0000000000000003, 0x0000000000000007, 0x000000000000000F, 0x000000000000001F, 0x000000000000003F, 0x000000000000007F, 0x00000000000000FF,
							0x00000000000001FF, 0x00000000000003FF, 0x00000000000007FF, 0x0000000000000FFF, 0x0000000000001FFF, 0x0000000000003FFF, 0x0000000000007FFF, 0x000000000000FFFF,
							0x000000000001FFFF, 0x000000000003FFFF, 0x000000000007FFFF, 0x00000000000FFFFF, 0x00000000001FFFFF, 0x00000000003FFFFF, 0x00000000007FFFFF, 0x0000000000FFFFFF,
							0x0000000001FFFFFF, 0x0000000003FFFFFF, 0x0000000007FFFFFF, 0x000000000FFFFFFF, 0x000000001FFFFFFF, 0x000000003FFFFFFF, 0x000000007FFFFFFF, 0x00000000FFFFFFFF,
							0x00000001FFFFFFFF, 0x00000003FFFFFFFF, 0x00000007FFFFFFFF, 0x0000000FFFFFFFFF, 0x0000001FFFFFFFFF, 0x0000003FFFFFFFFF, 0x0000007FFFFFFFFF, 0x000000FFFFFFFFFF,
							0x000001FFFFFFFFFF, 0x000003FFFFFFFFFF, 0x000007FFFFFFFFFF, 0x00000FFFFFFFFFFF, 0x00001FFFFFFFFFFF, 0x00003FFFFFFFFFFF, 0x00007FFFFFFFFFFF, 0x0000FFFFFFFFFFFF,
							0x0001FFFFFFFFFFFF, 0x0003FFFFFFFFFFFF, 0x0007FFFFFFFFFFFF, 0x000FFFFFFFFFFFFF, 0x001FFFFFFFFFFFFF, 0x003FFFFFFFFFFFFF, 0x007FFFFFFFFFFFFF, 0x00FFFFFFFFFFFFFF,
							0x01FFFFFFFFFFFFFF, 0x03FFFFFFFFFFFFFF, 0x07FFFFFFFFFFFFFF, 0x0FFFFFFFFFFFFFFF, 0x1FFFFFFFFFFFFFFF, 0x3FFFFFFFFFFFFFFF, 0x7FFFFFFFFFFFFFFF, 0xFFFFFFFFFFFFFFFF};

struct comparator {
	bool operator() (std::pair<unsigned long, unsigned long> i,std::pair<unsigned long, unsigned long> j) {
		return (i.second>j.second);
	}
};
extern void output_bitsize(unsigned long x);

selectBitVector::selectBitVector(int_vector<1> bv) {
	build(bv,0);
}
selectBitVector::selectBitVector(int_vector<1> bv, unsigned int recursionDepth) {
	this->recursionDepth == recursionDepth;
	build(bv, recursionDepth);
}

void selectBitVector::build(int_vector<1> bv,unsigned int recursionDepth) {
	vector<vector<unsigned long> >	tempLevelBSparseTable;		//table for sparse small blocks
	comb cb(1<<7);
	inputSize = bv.size();
	totalOnes = 0;					//total number of ones within the input data;
	for (unsigned long i = 0; i < inputSize/32 + 1; i++) {
		totalOnes += bit_magic::b1Cnt(bv.get_int(i*32,32));
	}
	unsigned long levelASize = (totalOnes - 1) / OnesSelLvlA + 1;	//this is the number of blocks, the data structures will have one more element, for watcher reasons
	unsigned long levelBSize = (totalOnes - 1) / OnesSelLvlB + 1;
	std::map<unsigned long,unsigned long> blockCount;
	std::vector<canonicalEncoder> encoders;
	encoders.reserve(SelLvlB + 1);
	decoders.reserve(SelLvlB + 1);
	for (unsigned long i = 0; i < SelLvlB + 1; i++) {
		encoders.push_back(canonicalEncoder());
	}

	printf("levelA = %d, levelB = %d, levelASize = %d levelBSize = %d\n", OnesSelLvlA, OnesSelLvlB, levelASize, levelBSize); //debugcode
	levelA = new unsigned long[levelASize + 1];
	levelASparseIndicator.resize(levelASize + 1);
	levelB.resize(levelBSize + 1);
	levelBSparseIndicator.resize(levelBSize + 1);
	levelC = new unsigned long[levelBSize + 1];

	#if _FIND_BLOCK_BORDER_MODE == _2LVLPTRS
	levelAptrs = new unsigned long[levelASize + 1];
	levelBptrs.resize(levelBSize + 1);
	#endif	//2LVLPTRS

	for (unsigned long i = 0; i < levelASize+1; i++){
		levelA[i] = 0;
		levelASparseIndicator[i] = 0;
	}
	for (unsigned long i = 0; i < levelBSize+1; i++){
		levelB[i] = 0;
		levelBSparseIndicator[i] = 0;
	}
	for (unsigned long i = 0; i < levelBSize; i++) {
		levelC[i] = 0;
	}
	unsigned long 	currentLevelA = 0, currentBlock = 0;// currentBlock2 = 0;
	bool		currentAIsSparse = false, currentBIsSparse = false;
	unsigned long	levelASparseIndex = 0;
	unsigned long	levelBSparseIndex = 0;
	unsigned long 	ones = 0;
	unsigned long 	i = 0;

	{
		//start of first large block
		levelA[0] = 0;
		currentLevelA = 0;
		//check if it will be a dense or sparse block
		unsigned long onesInMaxBlock = 0;
		for (unsigned long j = 0; j < SelLvlA && j < inputSize; j += 32) {
			onesInMaxBlock += bit_magic::b1Cnt(bv.get_int(j,32));
		}
		if (onesInMaxBlock <= OnesSelLvlA) {
			currentAIsSparse = true;
			levelASparseIndicator[0] = 1;
			levelASparseIndex = levelASparseTable.size();
			vector<unsigned long> x;
			x.reserve(OnesSelLvlA);
			x.push_back(0);			//select(0) = 0
			levelASparseTable.push_back(x);
		}				
		//start of first small block
		levelB[0] = 0;
		//check if it will be a sparse block
		currentBIsSparse = false;
		if (bit_magic::b1Cnt(bv.get_int(0, SelLvlB)) <= OnesSelLvlB && !currentAIsSparse) {
			currentBIsSparse = true;
			levelBSparseIndicator[0] = 1;
			levelBSparseIndex = tempLevelBSparseTable.size();
			vector<unsigned long> x;
			x.reserve(OnesSelLvlB);
			x.push_back(0);			//select(0) = 0
			tempLevelBSparseTable.push_back(x);
		}
	}
	for (i = 0; i < inputSize; i++) {
		//process bit
		if (bv[i] == 1) {
			ones++;
			if (ones%OnesSelLvlA == 0) {
				//start of next large block
				levelA[ones/OnesSelLvlA] = i;
				currentLevelA = i;
				//check if it will be a dense or sparse block
				unsigned long onesInMaxBlock = 0;
				for (unsigned long j = i; j < i + SelLvlA && j < inputSize; j += 32) {
					onesInMaxBlock += bit_magic::b1Cnt(bv.get_int(j,32));
				}
				currentAIsSparse = false;
				if (onesInMaxBlock <= OnesSelLvlA) {
					currentAIsSparse = true;
					levelASparseIndicator[ones/OnesSelLvlA] = 1;
					levelASparseIndex = levelASparseTable.size();
					vector<unsigned long> x;
					x.reserve(OnesSelLvlA);
					levelASparseTable.push_back(x);
				}				
			}
			if (ones%OnesSelLvlB == 0) {
				//start of next small block
				levelB[ones/OnesSelLvlB] = i - currentLevelA;
				//check if it will be a sparse block
				currentBIsSparse = false;
				if (!currentBIsSparse && ones != 0) { //store and count currentBlock
					levelC[ones/OnesSelLvlB - 1] = currentBlock;
					encoders[bit_magic::l1BP(currentBlock) + 1].include(currentBlock);
					currentBlock = 0;
				}
				if (bit_magic::b1Cnt(bv.get_int(i, SelLvlB)) <= OnesSelLvlB && !currentAIsSparse) {
					currentBIsSparse = true;
					levelBSparseIndicator[ones/OnesSelLvlB] = 1;
					levelBSparseIndex = tempLevelBSparseTable.size();
					vector<unsigned long> x;
					x.reserve(OnesSelLvlB);
					tempLevelBSparseTable.push_back(x);
				}
			}
			if (currentAIsSparse) levelASparseTable[levelASparseIndex].push_back(i);
			else if (currentBIsSparse) tempLevelBSparseTable[levelBSparseIndex].push_back(i - currentLevelA);
			else {
				currentBlock = ((currentBlock << 1) | 1UL);
				
			}
		}
		else {	//bv[i] == 0
			if (!currentAIsSparse && !currentBIsSparse) currentBlock = currentBlock << 1;
		}
	}
	//store last block(s)
	if (currentAIsSparse) {
		for (auto i = levelASparseTable[levelASparseIndex].size(); i < OnesSelLvlA ;i++)
		levelASparseTable[levelASparseIndex].push_back(inputSize);
	}
	if (currentBIsSparse) {
		for (auto i = tempLevelBSparseTable[levelBSparseIndex].size(); i < OnesSelLvlB ;i++)
		tempLevelBSparseTable[levelBSparseIndex].push_back(inputSize - currentLevelA);
	}
	levelC[levelBSize -1 ] = currentBlock;
	levelB[levelBSize] = i - currentLevelA;
	levelA[levelASize] = i;
	unsigned long compressedSize = 0;
	for (std::vector<canonicalEncoder>::iterator iter = encoders.begin(); iter != encoders.end(); iter++) {
		iter -> calcCode();
		compressedSize += iter -> predictSize();
		decoders.push_back(iter -> getDecoder());
	}
	#if (_FIND_BLOCK_BORDER_MODE == _SDSLSELECT_MCL) || (_FIND_BLOCK_BORDER_RECURSION == _ON) || (_FIND_BLOCK_BODRED_MODE == _SDSLSELECT_NND)
	compressedSize += tempLevelBSparseTable.size();		//even blocks treated special have to be indicated by a 1 within the beginningsarray to get propper results by selectquerries on i
	compressedSize += levelASparseTable.size() * BperA;
	#endif //select or recursion
	
	printf("\ncompressed Size is %d", compressedSize); output_bitsize(compressedSize); printf(" ratio: %f", ((double) compressedSize)/((double) inputSize));
	unsigned long size = 0;
	for (unsigned long i = 0; i < decoders.size(); i++) {
		size += decoders[i]->size();
	}
	printf("\nTable Size is %d", size);
	printf("\nnumber of large sparse blocks: %d", levelASparseTable.size()); printf(" ratio: %f", ((double) levelASparseTable.size())/((double) levelASize));fflush(stdout);
	printf("\nnumber of small sparse blocks: %d", tempLevelBSparseTable.size()); printf(" ratio: %f", ((double) tempLevelBSparseTable.size())/((double) levelBSize));fflush(stdout);
	//fill levelCcompressed
	unsigned long r = 0;
	levelCcompressed.resize(compressedSize);
	#if (_FIND_BLOCK_BORDER_MODE == _SDSLSELECT_MCL) || (_FIND_BLOCK_BORDER_MODE == _SDSLSELECT_NND)
	levelCbeginnings.resize(compressedSize+1);		//an additional final 1 to mark the end of the last block
	for(unsigned long i = 0; i < levelCbeginnings.size();i++)
		levelCbeginnings[i] = 0;
	levelCbeginnings[compressedSize] = 1;
	#endif //_SDSLSELECT
	for(unsigned long i = 0; i < levelBSize; i++) {
		if (i% BperA == 0) {
			#if _FIND_BLOCK_BORDER_MODE == _2LVLPTRS
			levelAptrs[i/BperA] = r;
			#endif	//2LVLPTRS

			currentLevelA = r;
		}
		#if _FIND_BLOCK_BORDER_MODE == _2LVLPTRS
		levelBptrs[i] = r - currentLevelA;
		#endif	//2LVLPTRS

		if ((levelASparseIndicator[i / BperA] == 0) && (levelBSparseIndicator[i] == 0)) {
			unsigned long length = bit_magic::l1BP(levelC[i]) + 1;
			unsigned long blockCode = encoders[length].encode(levelC[i]);
			unsigned long codeLength = encoders[length].getLength();
			levelCcompressed.set_int(r, blockCode, codeLength);
			#if (_FIND_BLOCK_BORDER_MODE == _SDSLSELECT_MCL) || (_FIND_BLOCK_BORDER_MODE == _SDSLSELECT_NND)
			levelCbeginnings[r] = 1;
			#endif //SDSLSELECT
			r+= codeLength;
		}
	#if ((_FIND_BLOCK_BORDER_MODE == _SDSLSELECT_MCL) || (_FIND_BLOCK_BORDER_RECURSION == _ON) || (_FIND_BLOCK_BORDER_MODE == _SDSLSELECT_NND))
		else {
			levelCbeginnings[r] = 1;
			r += 1;
		}
	#endif //select or recursion
	}
	#if _FIND_BLOCK_BORDER_MODE == _2LVLPTRS
	levelAptrs[levelASize] = r;
	if(levelBSize%levelASize == 0) levelBptrs[levelBSize] = 0;		//next small block would be in next large block
	else levelBptrs[levelBSize] = r - currentLevelA;
	#endif	//2LVLPTRS
	#if _FIND_BLOCK_BORDER_MODE == _SDSLSELECT_MCL
	levelCbeginningsSelector = new select_support_mcl<1,1>(&levelCbeginnings);
	#endif	//SDSLSELECT_MCL
	#if _FIND_BLOCK_BORDER_MODE == _SDSLSELECT_NND
	levelCbeginningsSelector = new nearest_neighbour_dictionary<16>(levelCbeginnings);
	#endif //SDSLSELECT_NND
	#if _FIND_BLOCK_BORDER_RECURSION == _ON
	if (recursionDepth > 0) levelCbeginningsRecursion = new selectBitVector(levelCbeginnings, recursionDepth - 1);
	this->recursionDepth = recursionDepth;
	#endif	//RECURSION
	levelBSparseTable.resize(tempLevelBSparseTable.size());
	vector<vector<unsigned long> >::iterator		tempBlock = tempLevelBSparseTable.begin();
	vector<int_vector<logSelLvlA> >::iterator	finalBlock = levelBSparseTable.begin();
	i = 0;
	for (; tempBlock != tempLevelBSparseTable.end();) {
		vector<unsigned long>::iterator temp = tempBlock->begin();
		finalBlock->resize(OnesSelLvlA);
		int_vector<logSelLvlA>::iterator final = finalBlock->begin();
		for (;temp != tempBlock->end();) {
			*final = *temp;
			final++; temp++;
		}
		tempBlock++; finalBlock++; i++;
	}
	levelASparseRanker = nearest_neighbour_dictionary<NND_SAMPLES>(levelASparseIndicator);
	levelBSparseRanker = nearest_neighbour_dictionary<NND_SAMPLES>(levelBSparseIndicator);

	

	return;
}

unsigned long selectBitVector::decode(unsigned long i, unsigned long blockLength) const{
	unsigned long start, end, codeLength, code;
	#ifdef __DEBUG__
		if (debug) {
			printf("i=%ld, blocklength = %ld\n", i, blockLength);
		}
	#endif //debug
	#if _FIND_BLOCK_BORDER_RECURSION == _ON
	if (recursionDepth == 0) {
	#endif	//RECURSION
		#if _FIND_BLOCK_BORDER_MODE == _2LVLPTRS
		start = levelAptrs[i/BperA] + levelBptrs[i];
		end = levelAptrs[(i+1)/BperA] + levelBptrs[i+1];
		#endif	//2LVLPTRS
		#if ((_FIND_BLOCK_BORDER_MODE == _SDSLSELECT_MCL) || (_FIND_BLOCK_BORDER_MODE == _SDSLSELECT_NND))
		start = levelCbeginningsSelector->select(i+1);
		end = levelCbeginningsSelector -> select(i+2);
		#endif //SDSLSELECT
	#if _FIND_BLOCK_BORDER_RECURSION == _ON
	}
	else {
		start = levelCbeginningsRecursion->select(i);
		end = levelCbeginningsRecursion->select(i+1);
	}
	#endif	//RECURSION

	codeLength = end-start;
	#ifdef __DEBUG__
		if (debug) {
			printf("start = %ld, end = %ld, codelength = %ld\n", start, end, codeLength);
		}
	#endif //debug
	code = levelCcompressed.get_int(start, codeLength);
	#ifdef __DEBUG__
		if (debug) {
			printf("code = %lx\n", code);
		}
	#endif //debug
	auto ret = decoders[blockLength]->decode(code, codeLength);
	#ifdef __DEBUG__
		if (debug) {
			printf("ret = %lx\n", ret);
		}
	#endif //debug
	return ret;
}

unsigned long selectBitVector::select(unsigned long i) const {
	if (i == 0) return 0;
	unsigned long levelBStart = 0, levelBEnd = 0, code = 0, block = 0, inBlock = 0, blockLength = 0;
	if (levelASparseIndicator[i/OnesSelLvlA] == 1) { //handle sparse large block
		#ifdef __DEBUG__
			if (debug) {
				printf("ASparse: i = %ld, return = %ld\n", i, (unsigned long)levelASparseTable[levelASparseRanker.rank(i/OnesSelLvlA)][i%OnesSelLvlA]);
			}
		#endif //debug
		return levelASparseTable[levelASparseRanker.rank(i/OnesSelLvlA)][i%OnesSelLvlA];
	}

	unsigned long levelAStart = levelA[i/OnesSelLvlA];

	if (levelBSparseIndicator[i/OnesSelLvlB] == 1) { //handle sparse small block
		#ifdef __DEBUG__
			if (debug) {
				printf("BSparse: i = %ld, levelAStart = %ld, return = %ld\n", i, levelAStart, (unsigned long)levelBSparseTable[levelBSparseRanker.rank(i/OnesSelLvlB)][i%OnesSelLvlB] + levelAStart);
				printf("levelBSparseRanker.rank(%d) = %d, i%%OnesSelLvlB = %d\n", i/OnesSelLvlB, levelBSparseRanker.rank(i/OnesSelLvlB), i%OnesSelLvlB);
			}
		#endif //debug
		return levelBSparseTable[levelBSparseRanker.rank(i/OnesSelLvlB)][i%OnesSelLvlB] + levelAStart;
	}

	levelBStart = levelB[i/OnesSelLvlB] + levelAStart;
	levelBEnd = ((i/OnesSelLvlB+1)%BperA == 0) ? (levelA[i/OnesSelLvlA + 1]) : (levelB[i/OnesSelLvlB + 1] + levelAStart);	//last small block in large block ? ... : ...
	blockLength = levelBEnd-levelBStart;
	block = decode(i/OnesSelLvlB, blockLength);
	inBlock = blockLength - bit_magic::i1BP(block, OnesSelLvlB - i%OnesSelLvlB) - 1;
	#ifdef __DEBUG__
		if (debug) {
			printf("\selectBitVector::select: i = %ld, levelAStart = %ld, levelBStart = %ld, levelBEnd = %ld, blockLength = %ld, block = %lx, inBlock = %ld\n", i, levelAStart, levelBStart, levelBEnd, blockLength, block, inBlock);
		}
	#endif //debug

	return levelBStart + inBlock;
}

unsigned long selectBitVector::rank(unsigned long i) const {
	unsigned long low = 0, high = (totalOnes - 1) / OnesSelLvlA + 1, mid = 0, ret = 0, rnklow, rnkhigh, rnkmid;
#ifdef rnkSampling
	low = rnkSamples[i/selSampleDensity];
	high = rnkSamples[i/selSampleDensity+1] + 1;
	
#endif
	rnklow = levelA[low];
	rnkhigh = levelA[high];
//	rnkhigh = totalOnes;
	#ifdef __DEBUG__
		if (debug) {
			printf("1low: levelA(%ld) = %ld, high: levelA(%ld) = %ld, ret = %ld, i = %ld x\n", low, rnklow, high, rnkhigh, ret, i);
		}
	#endif //debug

	//binary search on level A
	do {
		mid = (high + low) / 2;
		rnkmid = levelA[mid];
		if (rnkmid < i) {
			low = mid;
			rnklow = rnkmid;
		}
		else {
			high = mid;
			rnkhigh = rnkmid;
		}
		#ifdef __DEBUG__
			if (debug) {
				printf("2low: levelA(%ld) = %ld, high: levelA(%ld) = %ld, ret = %ld, i = %ld x\n", low, rnklow, high, rnkhigh, ret, i);
			}
		#endif //debug
	} while (low + 1 < high);

	//binary search on level B
	//handle sparse A block
	if (levelASparseIndicator[low] == 1) {
		ret += low * OnesSelLvlA;
		const std::vector<unsigned long>* block = &(levelASparseTable[levelASparseRanker.rank(low)]);
		low = 0;
		high = OnesSelLvlA;
/*		if ((*block)[high] < i) {
			ret += high;
			#ifdef __DEBUG__
				if (debug) {
					printf("3.1low: levelB(%ld) = %ld, high: levelB(%ld) = %ld, ret = %ld, i = %ld x\n", low, rnklow, high, rnkhigh, ret, i);
				}
			#endif //debug
			return ret;
		}*/
		do {
			mid = (high + low) / 2;
			rnkmid = (*block)[mid];
			if (rnkmid < i) {
				low = mid;
				rnklow = rnkmid;
			}
			else {
				high = mid;
				rnkhigh = rnkmid;
			}
			#ifdef __DEBUG__
				if (debug) {
					printf("3low: block(%ld) = %ld, high: block(%ld) = %ld, ret = %ld, i = %ld x\n", low, rnklow, high, rnkhigh, ret, i);
				}
			#endif //debug
		} while (low + 1 < high);
		ret += low;
		return ret;
	}
	//transform to level B querry
	i = i - rnklow;
	low = low * BperA;
	high = low + BperA;
	rnkhigh = rnkhigh - rnklow;
	rnklow = 0;	//rnklow - rnklow

	//dense level A
	#ifdef __DEBUG__
		if (debug) {
			printf("4low: levelB(%ld) = %ld, high: levelB(%ld) = %ld, ret = %ld, i = %ld x\n", low, rnklow, high, rnkhigh, ret, i);
		}
	#endif //debug
	do {
		mid = (high + low) / 2;
		rnkmid = levelB[mid];
		if (rnkmid < i) {
			low = mid;
			rnklow = rnkmid;
		}
		else {
			high = mid;
			rnkhigh = rnkmid;
		}
		#ifdef __DEBUG__
			if(debug) {
				printf("5low: levelB(%ld) = %ld, high: levelB(%ld) = %ld, ret = %ld, i = %ld x\n", low, rnklow, high, rnkhigh, ret, i);
			}
		#endif //debug
	} while (low + 1 < high);

	//handle sparse B block
	if (levelBSparseIndicator[low] == 1) {
		const sdsl::int_vector<logSelLvlA>* block = &(levelBSparseTable[levelBSparseRanker.rank(low)]);
		ret += low * OnesSelLvlB;
		low = 0;
		high = OnesSelLvlB;
/*		if ((*block)[high] < i) {
			ret += high;
			return ret;
		}*/
		do {
			mid = (high + low) / 2;
			rnkmid = (*block)[mid];
			if (rnkmid < i) {
				low = mid;
				rnklow = rnkmid;
			}
			else {
				high = mid;
				rnkhigh = rnkmid;
			}
			#ifdef __DEBUG__
				if(debug) {
					printf("5.2low: levelB(%ld) = %ld, high: levelB(%ld) = %ld, ret = %ld, i = %ld x\n", low, rnklow, high, rnkhigh, ret, i);
				}
			#endif //debug
		} while (low + 1 < high);
		ret += low;
		return ret;
	}
	//dense level B
	//transform to inblock querry
	ret += low * OnesSelLvlB;
	i = i - rnklow;
//	low = low * OnesSelLvlB;
//	high = low + OnesSelLvlB;	//not used
//	rnkhigh = rnkhigh - rnklow;	//not used
//	rnklow = 0;			//not used

	#ifdef __DEBUG__
		if (debug) {
			printf("6low: levelA(%ld) = %ld, high: levelA(%ld) = %ld, ret = %ld, i = %ld x\n", low, rnklow, high, rnkhigh, ret, i);
			printf("inputsize = %d\n", inputSize);
		}
	#endif //debug

	//decode block
	
//	unsigned long levelAStart = levelA[low/OnesSelLvlA];
//	unsigned long levelBStart = levelB[low/OnesSelLvlB] + levelAStart;
//	unsigned long levelBEnd = ((low/OnesSelLvlB+1)%BperA == 0) ? (levelA[low/OnesSelLvlA + 1]) : (levelB[low/OnesSelLvlB + 1] + levelAStart);	//last small block in large block ? ... : ...
	unsigned long blockLength = rnkhigh - rnklow;
//	unsigned long blockLength = levelBEnd-levelBStart;
	unsigned long block = decode(low, blockLength);
	#ifdef __DEBUG__
	if (debug) {
//		printf("levelAStart = %ld, levelBStart = %ld, levelBEnd = %ld, blockLength = %ld, block = %lx\n",levelAStart, levelBStart, levelBEnd, blockLength, block);
//		printf("levelAStart = %ld, ", levelAStart);
//		printf("levelBStart = %ld, ", levelBStart);
//		printf("levelBEnd = %ld, ", levelBEnd);
		printf("blockLength = %ld, ", blockLength);
		printf("block = %lx, ", block);
		printf("low = %ld, ", low);
		printf("i = %ld, " , i);
		printf("OnesSelLvlB = %ld, ", OnesSelLvlB);
		printf("low/OSLB = %ld \n", low/OnesSelLvlB);
		printf("low/OSLA = %ld \t", low/OnesSelLvlA);
		printf("low/OSLB+1 % BpA = %ld \t", (low/OnesSelLvlB+1)%BperA);
		printf("b1cntarg = %lx\t", block >> (blockLength-i));
		printf("ret = %d \t", ret);
	}
	#endif //debug
	return ret + bit_magic::b1Cnt(block >> (blockLength-i)) - 1;
}


unsigned long selectBitVector::size() {
	unsigned long ret = 0;
	ret += ((totalOnes - 1) / OnesSelLvlA + 2) * sizeof(unsigned long) * 8;	//levelA
	ret += levelB.size() * logSelLvlA;					//levelB
	ret += levelCcompressed.size();						//levelC
	for (vector<decoder*>::iterator iter = decoders.begin(); iter != decoders.end(); iter++) {	//decoders
		ret += (*iter)->size() * 8;
	}
	for (vector<vector<unsigned long> >::iterator iter = levelASparseTable.begin(); iter != levelASparseTable.end(); iter++) {	//levelASparseTable
		ret += iter->size() * sizeof(unsigned long) * 8;
	}
	for (vector<int_vector<logSelLvlA> >::iterator iter = levelBSparseTable.begin(); iter != levelBSparseTable.end(); iter++) {	//levelBSparseTable
		ret += iter->size() * logSelLvlA;
	}
	#if _FIND_BLOCK_BORDER_RECURSION == _ON
	if (recursionDepth == 0) {
	#endif	//RECURSION

		#if _FIND_BLOCK_BORDER_MODE == _2LVLPTRS
		((inputSize - 1) / LEVELA + 2) * sizeof(unsigned long) * 8;	//levelAptrs
		levelBptrs.size() * logLvlA;					//levelBptrs
		#endif	//2LVLPTRS
		#if ((_FIND_BLOCK_BORDER_MODE == _SDSLSELECT_MCL) || (_FIND_BOLCK_BORDER_MODE == _SDSLSELECT_NND))
		ret += sdsl::util::get_size_in_bytes(levelCbeginningsSelector) * 8;
		#endif //SDSLSELECT
	#if _FIND_BLOCK_BORDER_RECURSION == _ON
	}
	else ret += levelCbeginningsRecursion->size();
	#endif	//RECURSION
	
	ret += sdsl::util::get_size_in_bytes(levelASparseIndicator) * 8;
	ret += sdsl::util::get_size_in_bytes(levelBSparseIndicator) * 8;
	ret += sdsl::util::get_size_in_bytes(levelASparseRanker) * 8;
	ret += sdsl::util::get_size_in_bytes(levelBSparseRanker) * 8;

	#if ((_FIND_BLOCK_BORDER_MODE == _SDSLSELECT_MCL) || (_FIND_BLOCK_BORDER_MODE == _SDSLSELECT_NND) || (_FIND_BLOCK_BORDER_RECURSION == _ON))
	ret += sdsl::util::get_size_in_bytes(levelCbeginnings) * 8;
	#endif //SELECT or RECURSION
	return ret;
}
