#include <iostream>
#include <ctime>
#include <cstdlib>
#include <cmath>
#include <BitSequenceRRR.h>
#include <BitSequenceRG.h>
#include <BitSequenceSDArray.h>
#include <BitSequenceDArray.h>
#include <sdsl/vectors.hpp>
//#include <sdsl/bitmagic.hpp> //testing only?
//#include <sdsl/select_support_mcl.hpp>
using namespace std;
using namespace cds_utils;
using namespace cds_static;

int main(int argc, char* argv[]){
	FILE* infp = NULL;
	infp = fopen(argv[1],"rb");
	if (infp == NULL){
		printf("cannot open %s\n",argv[1]);
		return -1;
	}
	fseek(infp,0,SEEK_END);
	unsigned int n = ftell(infp);
	rewind(infp);

	BitString bv(n);
	uint setCount = 0;
	for (uint i = 0; i < n; i++){
		int c = fgetc(infp);
		if (c == EOF){
			printf("unexpected error at reading from %s\n",argv[1]);
			return -1;
		}
		if (c == '1'){
			bv.setBit(i,true);
			setCount++;
		}
		else if (c == '0'){
			bv.setBit(i,false);
		}
		else {
			printf("unexpected error (2) at reading from %s\n",argv[1]);
			return -1;
		}
	}
	//BitSequenceRRR BSRRR(bv);
	//BitSequenceRG BSRRR(bv,20);  //choose 2,3,4 or 20 as factor (memory access faults ?!?)
	//BitSequenceSDArray BSRRR(bv);
	BitSequenceDArray BSRRR(bv);
	printf("size in Bits is %d\n", BSRRR.getSize()*8);
	sdsl::stop_watch* stoppie = new sdsl::stop_watch();
	unsigned int POSITIONS = 1000000;
	unsigned int REPEATS = 10;
	unsigned int * const position = (unsigned int *)calloc( POSITIONS, sizeof *position );

	for( long long i = 0; i < POSITIONS; i++) position[ i ] = rand() % n;
	unsigned int dummy = 0x12345678;
	clock_t start = clock();
	stoppie->start();
	for( int k = REPEATS; k-- != 0; )
		for( int i = 0; i < POSITIONS; i += 10 ) {
			dummy ^= BSRRR.rank1( position[ i ] );
			dummy ^= BSRRR.rank1( position[ i + 1 ] );
			dummy ^= BSRRR.rank1( position[ i + 2 ] );
			dummy ^= BSRRR.rank1( position[ i + 3 ] );
			dummy ^= BSRRR.rank1( position[ i + 4 ] );
			dummy ^= BSRRR.rank1( position[ i + 5 ] );
			dummy ^= BSRRR.rank1( position[ i + 6 ] );
			dummy ^= BSRRR.rank1( position[ i + 7 ] );
			dummy ^= BSRRR.rank1( position[ i + 8 ] );
			dummy ^= BSRRR.rank1( position[ i + 9 ] );
		}
	stoppie->stop();
//	printf("\n%d\t%d\n", start, end);
	double s = stoppie->get_user_time() / 1000;
	printf( "%fs, %f ranks/s, hrg%fns/rank, r3j%f \n", s, (double)(REPEATS * POSITIONS) / s, ((double)(1E9 * s)) / (double)(REPEATS * POSITIONS), (double) (BSRRR.getSize()*8) / n );fflush(stdout);
	printf( "%d\n", dummy);

/*
	clock_t end = clock();
	float s = (float)(end - start) / CLOCKS_PER_SEC;
	printf( "%f s, %f ranks/s, %f ns/rank\n", s, (float)(REPEATS * POSITIONS) / s, ((float)(1E9 * s)) / (float)(REPEATS * POSITIONS) );fflush(stdout);
	printf( "%d\n", dummy);
*/
	for( long long i = 0; i < POSITIONS; i++ ) position[ i ] = rand() % setCount;
	dummy = 0x12345678;
//	start = clock();
	stoppie->start();	
	for( int k = REPEATS; k-- != 0; )
		for( int i = 0; i < POSITIONS; i += 10 ) {
			dummy ^= BSRRR.select1( position[ i ] );
			dummy ^= BSRRR.select1( position[ i + 1 ] );
			dummy ^= BSRRR.select1( position[ i + 2 ] );
			dummy ^= BSRRR.select1( position[ i + 3 ] );
			dummy ^= BSRRR.select1( position[ i + 4 ] );
			dummy ^= BSRRR.select1( position[ i + 5 ] );
			dummy ^= BSRRR.select1( position[ i + 6 ] );
			dummy ^= BSRRR.select1( position[ i + 7 ] );
			dummy ^= BSRRR.select1( position[ i + 8 ] );
			dummy ^= BSRRR.select1( position[ i + 9 ] );
		}

		stoppie->stop();
		s = stoppie->get_user_time() / 1000;
		printf( "%fs, %f selects/s, hsg%fns/select, s3j%f \n", s, (double)(REPEATS * POSITIONS) / s, ((double)(1E9 * s)) / (double)(REPEATS * POSITIONS), (double)(BSRRR.getSize()*8) / n);fflush(stdout);
	printf( "%d\n", dummy);
	if (dummy == 42) printf("22");



	return 0;
}
