#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/timeb.h>

typedef unsigned char byte;
typedef unsigned short word;
typedef unsigned int dword;
#if 1
typedef unsigned int qword;
typedef word pb;
#define logD 4
#else
typedef unsigned long long qword;
typedef dword pb;
#define logD 5
#endif
#define PBS (sizeof(pb)*8)
#define D (1<<logD)
#define logM 5
#define M (1<<logM)
#define logP 8
#define P (1<<logP)
#define logLL 16    // size of word
#define LL (1<<logLL)
//#define logLLL 7
#define logLLL 5
//#define LLL 128
//#define LLL 32
#define LLL (1<<logLLL)
//#define logL 10
//#define logL (logLL-3)
#define logL (logLL-1-5)
#define L (1<<logL)

#ifndef min
 #define min(x,y) ((x)<(y)?(x):(y))
#endif

int msize=0;
#define mymalloc(p,n,f) {p = malloc((n)*sizeof(*p)); msize += (f)*(n)*sizeof(*p); /* if (f) printf("malloc %d bytes at line %d total %d\n",(n)*sizeof(*p),__LINE__,msize);  */ if ((p)==NULL) {printf("not enough memory (%d bytes) in line %d\n",msize,__LINE__); exit(1);};}

typedef struct timeb mytimestruct;
void mygettime(mytimestruct *t)
{
  ftime(t);
}
double mylaptime(mytimestruct *before,mytimestruct *after)
{
  double t;
  t = after->time - before->time;
  t += (double)(after->millitm - before->millitm)/1000;
  return t;
}


int blog(int x)
{
int l;
  l = 0;
  while (x>0) {
    x>>=1;
    l++;
  }
  return l;
}


int setbit(pb *B, int i,int x)
{
  int j,l;

  j = i / D;
  l = i % D;
  if (x==0) B[j] &= (~(1<<(D-1-l)));
  else if (x==1) B[j] |= (1<<(D-1-l));
  else {
    printf("error setbit x=%d\n",x);
    exit(1);
  }
  return x;
}

int setbit2(byte *B, int i,int x)
{
  int j,l;

  j = i / 8;
  l = i % 8;
  if (x==0) B[j] &= (~(1<<(8-1-l)));
  else if (x==1) B[j] |= (1<<(8-1-l));
  else {
    printf("error setbit2 x=%d\n",x);
    exit(1);
  }
  return x;
}

int setbits(pb *B, int i, int d, int x)
{
  int j;

  for (j=0; j<d; j++) {
    setbit(B,i+j,(x>>(d-j-1))&1);
  }
  return x;
}

int getbit(pb *B, int i)
{
  int j,l;

  //j = i / D;
  //l = i % D;
  j = i >> logD;
  l = i & (D-1);
  return (B[j] >> (D-1-l)) & 1;
}

int getbit2(byte *B, int i)
{
  int j,l;

  //j = i / D;
  //l = i % D;
  j = i >> 3;
  l = i & (8-1);
  return (B[j] >> (8-1-l)) & 1;
}

#if 1
dword getbits(pb *B, int i, int d)
{
  qword x,z;

  B += (i >> logD);
  i &= (D-1);
  if (i+d <= 2*D) {
    x = (((qword)B[0]) << D) + B[1];
    x <<= i;
    x >>= (D*2-1-d);
    x >>= 1;
  } else {
    x = (((qword)B[0])<<D)+B[1];
    z = (x<<D)+B[2];
    x <<= i;
    x &= ((1L<<D)-1)<<D;
    z <<= i;
    z >>= D;
    x += z;
    x >>= (2*D-d);
  }
  
  return x;
}
#endif

#if 0
dword getbits(pb *B, int i, int d)
{
  dword j,x;

  x = 0;
  for (j=0; j<d; j++) {
    x <<= 1;
    x += getbit(B,i+j);
  }
  return x;
}
#endif

static const unsigned int popCount[] = {
0,1,1,2,1,2,2,3,1,2,2,3,2,3,3,4,
1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,
1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,
2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,
1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,
2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,
2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,
3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,
1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,
2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,
2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,
3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,
2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,
3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,
3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,
4,5,5,6,5,6,6,7,5,6,6,7,6,7,7,8
};

static unsigned int selecttbl[8*256];

unsigned int popcount(dword x)
{
  dword r;
#if 0
  r = x;
  r = r - ((r>>1) & 0x77777777) - ((r>>2) & 0x33333333) - ((r>>3) & 0x11111111);
  r = ((r + (r>>4)) & 0x0f0f0f0f) % 0xff;
#elif 1
  r = x;
  r = ((r & 0xaaaaaaaa)>>1) + (r & 0x55555555);
  r = ((r & 0xcccccccc)>>2) + (r & 0x33333333);
  //r = ((r & 0xf0f0f0f0)>>4) + (r & 0x0f0f0f0f);
  r = ((r>>4) + r) & 0x0f0f0f0f;
  //r = ((r & 0xff00ff00)>>8) + (r & 0x00ff00ff);
  r = (r>>8) + r;
  //r = ((r & 0xffff0000)>>16) + (r & 0x0000ffff);
  r = ((r>>16) + r) & 63;
#else
  r = popCount[x & 0xff];
  x >>= 8;
  r += popCount[x & 0xff];
  x >>= 8;
  r += popCount[x & 0xff];
  x >>= 8;
  r += popCount[x & 0xff];
#endif
  return r;
}

unsigned int popcount8(dword x)
{
  dword r;
#if 1
  r = x;
  r = ((r & 0xaa)>>1) + (r & 0x55);
  r = ((r & 0xcc)>>2) + (r & 0x33);
  r = ((r>>4) + r) & 0x0f;
#else
  r = popCount[x & 0xff];
#endif
  return r;
}

typedef struct {
  int n,m;
  int size;
  pb *buf;
  //dword *s;
  dword *lp;
  dword *sl;
  word *ss;
  dword *p;
} selectd;

typedef struct {
  int n,m;
  int size;
  byte *buf;
  //dword *s;
  dword *lp;
  dword *sl;
  word *ss;
  dword *p;
} selectd2;

void make_selecttbl(void)
{
  int i,x,r;
  pb buf[1];

  for (x = 0; x < 256; x++) {
    setbits(buf,0,8,x);
    for (r=0; r<8; r++) selecttbl[(r<<8)+x] = -1;
    r = 0;
    for (i=0; i<8; i++) {
      if (getbit(buf,i)) {
	selecttbl[(r<<8)+x] = i;
	r++;
      }
    }
  }
}


int selectd_construct(selectd *select, int n, pb *buf)
{
  int i,j,m,ll;
  int nl,ns;
  int p,pp;
  int il,is,ml,ms;
  int r;
  dword *s;

  make_selecttbl();


  if (L/LLL == 0) {
    printf("ERROR: L=%d LLL=%d\n",L,LLL);
    exit(1);
  }

  m = 0;
  for (i=0; i<n; i++) m += getbit(buf,i);
  select->n = n;
  select->m = m;
  //printf("n=%d m=%d\n",n,m);

#if 0  
  mymalloc(select->buf,(n+PBS-1)/PBS,1);
  for (i=0; i<(n+PBS-1)/PBS; i++) {
    select->buf[i] = buf[i];
  }
#else
  select->buf = buf;
#endif

  mymalloc(s,m,0);
  //select->s = s;
  m = 0;
  for (i=0; i<n; i++) {
    if (getbit(buf,i)) {
      m++;
      s[m-1] = i;
    }
  }

  nl = (m-1) / L + 1;
  mymalloc(select->lp,nl+1,1);
  mymalloc(select->p,nl+1,1);

  for (r = 0; r < 2; r++) {
    ml = ms = 0;
    for (il = 0; il < nl; il++) {
      pp = s[il*L];
      select->lp[il] = pp;
      i = min((il+1)*L-1,m-1);
      p = s[i];
      //printf("%d ",p-pp);
      if (p - pp >= LL) {
	if (r == 1) {
	  for (is = 0; is < L; is++) {
	    if (il*L+is >= m) break;
	    select->sl[ml*L+is] = s[il*L+is];
	  }
	}
	select->p[il] = -(ml+1);
	ml++;
      } else {
	if (r == 1) {
	  for (is = 0; is < L/LLL; is++) {
	    if (il*L+is*LLL >= m) break;
	    select->ss[ms*(L/LLL)+is] = s[il*L+is*LLL] - pp;
	  }
	}
	select->p[il] = ms;
	ms++;
      }
    }
    if (r == 0) {
      mymalloc(select->sl,ml*L+1,1);
      mymalloc(select->ss,ms*(L/LLL)+1,1);
    }
  }
  free(s);
}

int selectd2_construct(selectd2 *select, int n, byte *buf)
{
  int i,j,m,ll;
  int nl,ns;
  int p,pp;
  int il,is,ml,ms;
  int r;
  dword *s;

  make_selecttbl();


  if (L/LLL == 0) {
    printf("ERROR: L=%d LLL=%d\n",L,LLL);
    exit(1);
  }

  m = 0;
  for (i=0; i<n; i++) m += getbit2(buf,i);
  select->n = n;
  select->m = m;
  //printf("n=%d m=%d\n",n,m);

  select->buf = buf;

  mymalloc(s,m,0);
  //select->s = s;
  m = 0;
  for (i=0; i<n; i++) {
    if (getbit2(buf,i)) {
      m++;
      s[m-1] = i;
    }
  }

  nl = (m-1) / L + 1;
  mymalloc(select->lp,nl+1,1);
  mymalloc(select->p,nl+1,1);

  for (r = 0; r < 2; r++) {
    ml = ms = 0;
    for (il = 0; il < nl; il++) {
      pp = s[il*L];
      select->lp[il] = pp;
      i = min((il+1)*L-1,m-1);
      p = s[i];
      //printf("%d ",p-pp);
      if (p - pp >= LL) {
	if (r == 1) {
	  for (is = 0; is < L; is++) {
	    if (il*L+is >= m) break;
	    select->sl[ml*L+is] = s[il*L+is];
	  }
	}
	select->p[il] = -((ml<<logL)+1);
	ml++;
      } else {
	if (r == 1) {
	  for (is = 0; is < L/LLL; is++) {
	    if (il*L+is*LLL >= m) break;
	    select->ss[ms*(L/LLL)+is] = s[il*L+is*LLL] - pp;
	  }
	}
	select->p[il] = ms << (logL-logLLL);
	ms++;
      }
    }
    if (r == 0) {
      mymalloc(select->sl,ml*L+1,1);
      mymalloc(select->ss,ms*(L/LLL)+1,1);
    }
  }
  free(s);
}

int selectd_select(selectd *select, int i,int f)
{
  int m;
  dword *s;
  int p,r;
  int il;
  int rr;
  pb x;
  pb *q;

  if (i == 0) return -1;

#if 0
  if (i > select->m) {
    printf("ERROR: m=%d i=%d\n",select->m,i);
    exit(1);
  }
#endif

  i--;

  il = select->p[i>>logL];
  if (il < 0) {
    il = -il-1;
    p = select->sl[(il<<logL)+(i & (L-1))];
  } else {
    p = select->lp[i>>logL];
    p += select->ss[(il<<(logL-logLLL))+(i & (L-1))/LLL];
    r = i - (i & (LLL-1));

    q = &(select->buf[p>>logD]);

    if (f == 1) {
      rr = p & (D-1);
      r -= popcount(*q >> (D-1-rr));
      p = p - rr;
      
      while (1) {
	rr = popcount(*q);
	if (r + rr >= i) break;
	r += rr;
	p += D;
	q++;
      }
      
      x = *q;
      while (1) {
	//rr = popcount(x >> (D-8));
	rr = popCount[x >> (D-8)];
	//rr = popcount8(x >> (D-8));
	if (r + rr >= i) break;
	r += rr;
	p += 8;
	x <<= 8;
      }
      p += selecttbl[((i-r-1)<<8)+(x>>(D-8))];
    } else {
      rr = p & (D-1);
      r -= popcount((~(*q) & ((1L<<D)-1)) >> (D-1-rr));
      p = p - rr;
      
      while (1) {
	rr = popcount(~(*q) & ((1L<<D)-1));
	if (r + rr >= i) break;
	r += rr;
	p += D;
	q++;
      }
      
      x = ~(*q) & ((1L<<D)-1);

      while (1) {
	//rr = popcount(x >> (D-8));
	rr = popCount[x >> (D-8)];
	//rr = popcount8(x >> (D-8));
	if (r + rr >= i) break;
	r += rr;
	p += 8;
	x <<= 8;
      }
      p += selecttbl[((i-r-1)<<8)+(x>>(D-8))];
    }
  }
  return p;
}

int selectd2_select(selectd2 *select, int i,int f)
{
  int m;
  dword *s;
  int p,r;
  int il;
  int rr;
  pb x;
  byte *q;

  if (i == 0) return -1;

#if 0
  if (i > select->m) {
    printf("ERROR: m=%d i=%d\n",select->m,i);
    exit(1);
  }
#endif

  i--;

  il = select->p[i>>logL];
  if (il < 0) {
    il = -il-1;
    //p = select->sl[(il<<logL)+(i & (L-1))];
    p = select->sl[il+(i & (L-1))];
  } else {
    p = select->lp[i>>logL];
    //p += select->ss[(il<<(logL-logLLL))+(i & (L-1))/LLL];
    p += select->ss[il+((i & (L-1))>>logLLL)];
    r = i - (i & (LLL-1));

    q = &(select->buf[p>>3]);

    if (f == 1) {
      rr = p & (8-1);
      r -= popCount[*q >> (8-1-rr)];
      //p = p - rr;
      
      while (1) {
	rr = popCount[*q];
	if (r + rr >= i) break;
	r += rr;
	//p += 8;
	q++;
      }
      p = (q - select->buf) << 3;
      p += selecttbl[((i-r-1)<<8)+(*q)];
    } else {
      rr = p & (8-1);
      r -= popCount[(*q ^ 0xff) >> (8-1-rr)];
      //p = p - rr;
      
      while (1) {
	rr = popCount[*q ^ 0xff];
	if (r + rr >= i) break;
	r += rr;
	//p += 8;
	q++;
      }
      p = (q - select->buf) << 3;
      p += selecttbl[((i-r-1)<<8)+(*q ^ 0xff)];
    }
  }
  return p;
}

int selectd2_select2(selectd2 *select, int i,int f, int *st, int *en)
{
  int m;
  dword *s;
  int p,r,p2;
  int il;
  int rr;
  pb x;
  byte *q;

  if (i == 0) {
    *st = -1;
    return -1;
  }

#if 0
  if (i > select->m) {
    printf("ERROR: m=%d i=%d\n",select->m,i);
    exit(1);
  }
#endif

  i--;

  il = select->p[i>>logL];
  if (il < 0) {
    il = -il-1;
    //p = select->sl[(il<<logL)+(i & (L-1))];
    p = select->sl[il+(i & (L-1))];

    if ((i>>logL) == ((i+1)>>logL)) {
      p2 = select->sl[il+((i+1) & (L-1))];
    } else {
      p2 = selectd2_select(select,i+2,f);
    }
  } else {
    p = select->lp[i>>logL];
    //p += select->ss[(il<<(logL-logLLL))+(i & (L-1))/LLL];
    p += select->ss[il+((i & (L-1))>>logLLL)];
    r = i - (i & (LLL-1));

    q = &(select->buf[p>>3]);

    if (f == 1) {
      rr = p & (8-1);
      r -= popCount[*q >> (8-1-rr)];
      //p = p - rr;
      
      while (1) {
	rr = popCount[*q];
	if (r + rr >= i) break;
	r += rr;
	//p += 8;
	q++;
      }
      p = (q - select->buf) << 3;
      p += selecttbl[((i-r-1)<<8)+(*q)];

      if ((i>>logL) == ((i+1)>>logL)) {
	i++;
	while (1) {
	  rr = popCount[*q];
	  if (r + rr >= i) break;
	  r += rr;
	  q++;
	}
	p2 = (q - select->buf) << 3;
	p2 += selecttbl[((i-r-1)<<8)+(*q)];
      } else {
	p2 = selectd2_select(select,i+2,f);
      }

    } else {
      rr = p & (8-1);
      r -= popCount[(*q ^ 0xff) >> (8-1-rr)];
      //p = p - rr;
      
      while (1) {
	rr = popCount[*q ^ 0xff];
	if (r + rr >= i) break;
	r += rr;
	//p += 8;
	q++;
      }
      p = (q - select->buf) << 3;
      p += selecttbl[((i-r-1)<<8)+(*q ^ 0xff)];

      if ((i>>logL) == ((i+1)>>logL)) {
	i++;
	while (1) {
	  rr = popCount[*q ^ 0xff];
	  if (r + rr >= i) break;
	  r += rr;
	  q++;
	}
	p2 = (q - select->buf) << 3;
	p2 += selecttbl[((i-r-1)<<8)+(*q ^ 0xff)];
      } else {
	p2 = selectd2_select(select,i+2,f);
      }
    }
  }
  *st = p;
  *en = p2;
  return p;
}

typedef struct {
  int n,m,d;
  int size;
  pb *hi;
  pb *low;
  selectd *sd0,*sd1;

} selects;

typedef struct {
  int n,m,d;
  int size;
  byte *hi;
  byte *low;
  selectd2 *sd0,*sd1;

} selects2;

typedef struct {
  int n,m,d;
  int size;
  byte *hi;
  pb *low;
  selectd2 *sd0,*sd1;

} selects3;

int selects_construct(selects *select, int n, pb *buf)
{
  int i,j,m,ll;
  int nl,ns;
  int p,pp;
  int il,is,ml,ms;
  int r,d,mm;
  pb *low;
  pb *buf2;
  selectd *sd0,*sd1;
  dword *ru;
  pb *rl;
  int wl;

  m = 0;
  for (i=0; i<n; i++) m += getbit(buf,i);
  select->n = n;
  select->m = m;

  mm = m;
  d = 0;
  while (mm < n) {
    mm <<= 1;
    d++;
  }
  printf("n=%d m=%d d=%d\n",n,m,d);
  select->d = d;

  mymalloc(buf2,(2*m+PBS-1)/PBS+1,1);
  mymalloc(low,(d*m+PBS-1)/PBS+1,1);
  select->hi = buf2;
  select->low = low;

  for (i=0; i<m*2; i++) setbit(buf2,i,0);
  for (i=0; i<m; i++) setbits(low,i*d,d,0);

  m = 0;
  for (i=0; i<n; i++) {
    if (getbit(buf,i)) {
      setbit(buf2,(i>>d)+m,1);
      setbits(low,m*d,d,i & ((1<<d)-1));
      m++;
    }
  }

  mymalloc(sd1,1,0);
  mymalloc(sd0,1,0);

  selectd_construct(sd1,m*2,buf2);
  select->sd1 = sd1;

#if 1
  for (i=0; i<m*2; i++) setbit(buf2,i,1-getbit(buf2,i));
  selectd_construct(sd0,m*2,buf2);
  select->sd0 = sd0;

  for (i=0; i<m*2; i++) setbit(buf2,i,1-getbit(buf2,i));
#endif
}

int selects2_construct(selects2 *select, int n, pb *buf)
{
  int i,j,m,ll;
  int nl,ns;
  int p,pp;
  int il,is,ml,ms;
  int r,d,mm;
  byte *low;
  byte *buf2;
  selectd2 *sd0,*sd1;
  dword *ru;
  pb *rl;
  int wl;

  m = 0;
  for (i=0; i<n; i++) m += getbit(buf,i);
  select->n = n;
  select->m = m;

  mm = m;
  d = 0;
  while (mm < n) {
    mm <<= 1;
    d++;
  }
  printf("n=%d m=%d d=%d\n",n,m,d);
  
  if (d > 8) {
    printf("ERROR: d=%d\n",d);
    exit(1);
  }
  //d = 8;

  select->d = d;

  mymalloc(buf2,(2*m+8-1)/8+1,1);
  mymalloc(low,m,1);
  select->hi = buf2;
  select->low = low;

  for (i=0; i<m*2; i++) setbit2(buf2,i,0);

  m = 0;
  for (i=0; i<n; i++) {
    if (getbit(buf,i)) {
      setbit2(buf2,(i>>d)+m,1);
      low[m] = i & ((1<<d)-1);
      m++;
    }
  }

  mymalloc(sd1,1,0);
  mymalloc(sd0,1,0);

  selectd2_construct(sd1,m*2,buf2);
  select->sd1 = sd1;

#if 1
  for (i=0; i<m*2; i++) setbit2(buf2,i,1-getbit2(buf2,i));
  selectd2_construct(sd0,m*2,buf2);
  select->sd0 = sd0;

  for (i=0; i<m*2; i++) setbit2(buf2,i,1-getbit2(buf2,i));
#endif
}

int selects3_construct(selects3 *select, int n, pb *buf)
{
  int i,j,m,ll;
  int nl,ns;
  int p,pp;
  int il,is,ml,ms;
  int r,d,mm;
  pb *low;
  byte *buf2;
  selectd2 *sd0,*sd1;
  dword *ru;
  pb *rl;
  int wl;

  m = 0;
  for (i=0; i<n; i++) m += getbit(buf,i);
  select->n = n;
  select->m = m;

  if (m == 0) return 0;

  mm = m;
  d = 0;
  while (mm < n) {
    mm <<= 1;
    d++;
  }
  printf("n=%d m=%d d=%d\n",n,m,d);
  
  select->d = d;

  mymalloc(buf2,(2*m+8-1)/8+1,1);
  mymalloc(low,(d*m+PBS-1)/PBS+1,1);
  select->hi = buf2;
  select->low = low;

  for (i=0; i<m*2; i++) setbit2(buf2,i,0);

  m = 0;
  for (i=0; i<n; i++) {
    if (getbit(buf,i)) {
      setbit2(buf2,(i>>d)+m,1);
      setbits(low,m*d,d,i & ((1<<d)-1));
      m++;
    }
  }

  mymalloc(sd1,1,0);
  mymalloc(sd0,1,0);

  selectd2_construct(sd1,m*2,buf2);
  select->sd1 = sd1;

#if 1
  for (i=0; i<m*2; i++) setbit2(buf2,i,1-getbit2(buf2,i));
  selectd2_construct(sd0,m*2,buf2);
  select->sd0 = sd0;

  for (i=0; i<m*2; i++) setbit2(buf2,i,1-getbit2(buf2,i));
#endif
}

int selects_select(selects *select, int i)
{
  int d,x;

#if 1
  if (i > select->m) {
    printf("ERROR: m=%d i=%d\n",select->m,i);
    exit(1);
  }
#endif

  if (i == 0) return -1;

  d = select->d;

  x = selectd_select(select->sd1,i,1) - (i-1);
  x <<= d;
  x += getbits(select->low,(i-1)*d,d);
  return x;

}

int selects2_select(selects2 *select, int i)
{
  int d,x;

#if 1
  if (i > select->m) {
    printf("ERROR: m=%d i=%d\n",select->m,i);
    exit(1);
  }
#endif

  if (i == 0) return -1;

  d = select->d;

  x = selectd2_select(select->sd1,i,1) - (i-1);
  x <<= d;
  x += select->low[i-1];
  return x;

}

int selects3_select(selects3 *select, int i)
{
  int d,x;

#if 1
  if (i > select->m) {
    printf("ERROR: m=%d i=%d\n",select->m,i);
    exit(1);
  }
#endif

  if (i == 0) return -1;

  d = select->d;

  x = selectd2_select(select->sd1,i,1) - (i-1);
  x <<= d;
  x += getbits(select->low,(i-1)*d,d);
  return x;

}

int selects_rank(selects *select, int i)
{
  int d,x,w,y;
  int r,j;
  int z,m;
  dword zz;

#if 1
  if (i > select->n) {
    printf("ERROR: n=%d i=%d\n",select->n,i);
    exit(1);
  }
#endif

  d = select->d;
  m = D/d;

  y = selectd_select(select->sd0,i>>d,0)+1;
  x = y - (i>>d);

  j = i - ((i>>d)<<d);

  r = 0;
  z = getbits(select->hi,y,m) << (D-m);
  zz = getbits(select->low,x*d,d*m);
  while (1) {
    //if (getbit(select->hi,y)==0) break;
    if ((z & (1<<(D-1))) == 0) break;
    //w = getbits(select->low,x*d,d);
    w = (zz >> ((m-1)*d)) & ((1<<d)-1);
    if (w >= j) {
      if (w == j) x++;
      break;
    }
    x++;
    y++;
    r++;
    z <<= 1;
    zz <<= d;
    if (r == m) {
      //printf("r == %d\n",m);
      r = 0;
      z = getbits(select->hi,y,m) << (D-m);
      zz = getbits(select->low,x*d,d*m);
    }
  }
  return x;
}

int selects2_rank(selects2 *select, int i)
{
  int d,x,w,y;
  int r,j;
  int z,m,ii;
  byte *q;

  d = select->d;

  ii = i>>d;
  y = selectd2_select(select->sd0,ii,0)+1;
  x = y - ii;

  j = i - (ii<<d);

  q = &select->low[x];
 
  r = y & 7;
  z = select->hi[y>>3];
  while (1) {
    if (((z << r) & 0x80) == 0) break;
    w = *q++;
    if (w >= j) {
      if (w == j) x++;
      break;
    }
    x++;
    y++;
    r++;
    if (r == 8) {
      r = 0;
      z = select->hi[y>>3];
    }
  }
  //if (w == j) x++;
  //printf("r %d\n",r);

  return x;
}

int selects3_rank(selects3 *select, int i)
{
  int d,x,w,y,y1,y2;
  int r,j;
  int z,ii;
  pb *q;

  d = select->d;
  q = select->low;

  ii = i>>d;
  y = selectd2_select(select->sd0,ii,0)+1;
  //  selectd2_select2(select->sd0,ii,0,&y1,&y2);
  //y1++;  y2++;
  //printf("y %d y1 %d  %d\n",y,y1,y2-y1);

  x = y - ii;

  j = i - (ii<<d);

  r = y & 7;
  y >>= 3;
  z = select->hi[y];
  while (1) {
    if (((z << r) & 0x80) == 0) break;
    w = getbits(q,x*d,d);
    if (w >= j) {
      if (w == j) x++;
      break;
    }
    x++;
    r++;
    if (r == 8) {
      r = 0;
      y++;
      z = select->hi[y];
    }
  }

  return x;
}

#if 1

#define N 10485760

int main(int argc, char *argv[])
{
  selectd s1;
  selectd2 s12;
  selects s2;
  selects2 s22;
  selects3 s3;
  int i,r,n,rr;
  unsigned int hoge;
  FILE *infp = NULL;

  pb *B;
  byte *B2;
  dword *S,*R;

  double t;
  mytimestruct before,after;

  srand(2);

  n = N;
  r = 2;
  if (argc >= 2){
    r = atoi(argv[1]);
    if (r == 0) {
      infp = fopen(argv[2],"rb");
      if (infp == NULL){
	printf("cannot open %s\n",argv[2]);
	return -1;
      }
      fseek(infp,0,SEEK_END);
      n = ftell(infp);
      rewind(infp);
      //printf("n: %d\n",n);
    } else if (argc >= 3) {
      n = atoi(argv[2]);
    }
  }
  rr = r;

  mymalloc(B,(n+PBS-1+P)/PBS,0);
  //mymalloc(B2,(n+8-1+P)/8,0);
  //mymalloc(S,n+1,0);
  //mymalloc(R,n+1,0);

  for (i = 0; i < n; i++) {
    setbit(B,i,0);
    //setbit2(B2,i,0);
  }
  if (!infp) {
    for (i = 0; i < n; i++) {
      if (rand() % 100 < r) setbit(B,i,1);
    }
  } else {
    for (i = 0; i < n; i++){
      int c = fgetc(infp);
      if (c == EOF){
	printf("unexpected error at reading from %s\n",argv[2]);
	return -1;
      }
      if (c == '1'){
	setbit(B,i,1);
	setbit2(B2,i,1);
      }
      else if (c != '0'){
	printf("unexpected error (2) at reading from %s\n",argv[2]);
	return -1;
      }
    }
  }

  //selectd_construct(&s1,N,B);
  //selectd2_construct(&s12,N,B2);
  //selects_construct(&s2,n,B);
  //selects2_construct(&s22,n,B);
  selects3_construct(&s3,n,B);
  printf("used memory: %d bytes (%lf bpc)\n",msize,(double)msize*8/n);

#if 0
  r = 0;
  S[r] = -1;
  for (i=0; i<n; i++) {
    if (getbit(B,i)) {
      r++;
      S[r] = i;
    }
    R[i] = r;
  }
#endif

#if 1
  hoge = rand();
  mygettime(&before);
  for (i = 0; i < 100000000; i++) {
    int j;
    //j = (rand() % r)+1;
#ifdef RANDOM
    j = hoge % r + 1;
#else
    j = i % r + 1;
#endif
#ifdef CHECK
    if (selects3_select(&s3,j) != S[j]) {
      printf("ERROR: S[%d] = %d, s = %d\n",j,S[j],selects3_select(&s3,j));
    }
#else
    selects3_select(&s3,j);
#endif
    hoge = hoge * 1566083941U + 1;
  }
  mygettime(&after);
  t = mylaptime(&before,&after);
  printf("%d %f sada select time\n",rr,t);
#endif

#if 1
  mygettime(&before);
  hoge = rand();
  for (i = 0; i < 100000000; i++) {
    int j;
    //j = (rand() % n);
#ifdef RANDOM
    j = hoge % n;
#else
    j = i % n;
#endif
#ifdef CHECK
    if (selects3_rank(&s3,j) != R[j]) {
      printf("ERROR: (%d) R[%d] = %d, r = %d\n",getbit(B,i),j,R[j],selects3_rank(&s3,j));
    }
#else
    selects3_rank(&s3,j);
#endif
    hoge = hoge * 1566083941U + 1;
    //selects_rank(&s2,j);
  }
  mygettime(&after);
  t = mylaptime(&before,&after);
  printf("%d %f sada rank time\n",rr,t);
#endif

  return 0;
}

#endif
