#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/timeb.h>
#include <time.h>

typedef unsigned char byte;
typedef unsigned short word;
typedef unsigned int dword;

typedef dword pb;
#define logD 5

#define PBS (sizeof(pb)*8)
#define D (1<<logD)
#define logM 5
#define M (1<<logM)
#define logP 8
#define P (1<<logP)
#define logLL 16    // size of word
#define LL (1<<logLL)
//#define logLLL 7
#define logLLL 5
//#define LLL 128
//#define LLL 32
#define LLL (1<<logLLL)
//#define logL 10
//#define logL (logLL-3)
#define logL (logLL-1-5)
#define L (1<<logL)

#define logRR 8
#define RR (1<<logRR)
#define logRRR 6
#define RRR (1<<logRRR)


#ifndef min
 #define min(x,y) ((x)<(y)?(x):(y))
#endif

int msize=0;
#define mymalloc(p,n,f) {p = malloc((n)*sizeof(*p)); msize += (f)*(n)*sizeof(*p); /* if (f) printf("malloc %d bytes at line %d total %d\n",(n)*sizeof(*p),__LINE__,msize);  */ if ((p)==NULL) {printf("not enough memory (%d bytes) in line %d\n",msize,__LINE__); exit(1);};}

typedef struct timeb mytimestruct;
void mygettime(mytimestruct *t)
{
  ftime(t);
}
double mylaptime(mytimestruct *before,mytimestruct *after)
{
  double t;
  t = after->time - before->time;
  t += (double)(after->millitm - before->millitm)/1000;
  return t;
}


int blog(int x)
{
int l;
  l = 0;
  while (x>0) {
    x>>=1;
    l++;
  }
  return l;
}


int setbit(pb *B, int i,int x)
{
  int j,l;

  j = i / D;
  l = i % D;
  if (x==0) B[j] &= (~(1<<(D-1-l)));
  else if (x==1) B[j] |= (1<<(D-1-l));
  else {
    printf("error setbit x=%d\n",x);
    exit(1);
  }
  return x;
}

int setbits(pb *B, int i, int d, int x)
{
  int j;

  for (j=0; j<d; j++) {
    setbit(B,i+j,(x>>(d-j-1))&1);
  }
  return x;
}

int getbit(pb *B, int i)
{
  int j,l;

  //j = i / D;
  //l = i % D;
  j = i >> logD;
  l = i & (D-1);
  return (B[j] >> (D-1-l)) & 1;
}

static const unsigned int popCount[] = {
0,1,1,2,1,2,2,3,1,2,2,3,2,3,3,4,
1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,
1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,
2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,
1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,
2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,
2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,
3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,
1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,
2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,
2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,
3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,
2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,
3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,
3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,
4,5,5,6,5,6,6,7,5,6,6,7,6,7,7,8
};

static unsigned int selecttbl[8*256];

unsigned int popcount(pb x)
{
  pb r;
#if 0
  r = x;
  r = r - ((r>>1) & 0x77777777) - ((r>>2) & 0x33333333) - ((r>>3) & 0x11111111);
  r = ((r + (r>>4)) & 0x0f0f0f0f) % 0xff;
#elif 1
  r = x;
  r = ((r & 0xaaaaaaaa)>>1) + (r & 0x55555555);
  r = ((r & 0xcccccccc)>>2) + (r & 0x33333333);
  //r = ((r & 0xf0f0f0f0)>>4) + (r & 0x0f0f0f0f);
  r = ((r>>4) + r) & 0x0f0f0f0f;
  //r = ((r & 0xff00ff00)>>8) + (r & 0x00ff00ff);
  r = (r>>8) + r;
  //r = ((r & 0xffff0000)>>16) + (r & 0x0000ffff);
  r = ((r>>16) + r) & 63;
#else
  r = popCount[x & 0xff];
  x >>= 8;
  r += popCount[x & 0xff];
  x >>= 8;
  r += popCount[x & 0xff];
  x >>= 8;
  r += popCount[x & 0xff];
#endif
  return r;
}

unsigned int popcount8(pb x)
{
  dword r;
#if 1
  r = x;
  r = ((r & 0xaa)>>1) + (r & 0x55);
  r = ((r & 0xcc)>>2) + (r & 0x33);
  r = ((r>>4) + r) & 0x0f;
#else
  r = popCount[x & 0xff];
#endif
  return r;
}

typedef struct {
  int n,m;
  int size;
  pb *buf;
  //dword *s;
  dword *lp;
  dword *sl;
  word *ss;
  dword *p;

  dword *rl;
  byte *rs;

} selectd;

void make_selecttbl(void)
{
  int i,x,r;
  pb buf[1];

  for (x = 0; x < 256; x++) {
    setbits(buf,0,8,x);
    for (r=0; r<8; r++) selecttbl[(r<<8)+x] = -1;
    r = 0;
    for (i=0; i<8; i++) {
      if (getbit(buf,i)) {
	selecttbl[(r<<8)+x] = i;
	r++;
      }
    }
  }
}


int selectd_construct(selectd *select, int n, pb *buf)
{
  int i,j,m,ll;
  int nl,ns;
  int p,pp;
  int il,is,ml,ms;
  int r;
  dword *s;

  make_selecttbl();


  if (L/LLL == 0) {
    printf("ERROR: L=%d LLL=%d\n",L,LLL);
    exit(1);
  }

  m = 0;
  for (i=0; i<n; i++) m += getbit(buf,i);
  select->n = n;
  select->m = m;
  //printf("n=%d m=%d\n",n,m);

  select->buf = buf;

  mymalloc(s,m,0);
  //select->s = s;
  m = 0;
  for (i=0; i<n; i++) {
    if (getbit(buf,i)) {
      m++;
      s[m-1] = i;
    }
  }

  nl = (m-1) / L + 1;
  mymalloc(select->lp,nl+1,1);
  mymalloc(select->p,nl+1,1);

  for (r = 0; r < 2; r++) {
    ml = ms = 0;
    for (il = 0; il < nl; il++) {
      pp = s[il*L];
      select->lp[il] = pp;
      i = min((il+1)*L-1,m-1);
      p = s[i];
      //printf("%d ",p-pp);
      if (p - pp >= LL) {
	if (r == 1) {
	  for (is = 0; is < L; is++) {
	    if (il*L+is >= m) break;
	    select->sl[ml*L+is] = s[il*L+is];
	  }
	}
	select->p[il] = -(ml+1);
	ml++;
      } else {
	if (r == 1) {
	  for (is = 0; is < L/LLL; is++) {
	    if (il*L+is*LLL >= m) break;
	    select->ss[ms*(L/LLL)+is] = s[il*L+is*LLL] - pp;
	  }
	}
	select->p[il] = ms;
	ms++;
      }
    }
    if (r == 0) {
      mymalloc(select->sl,ml*L+1,1);
      mymalloc(select->ss,ms*(L/LLL)+1,1);
    }
  }
  free(s);

  mymalloc(select->rl,n/RR+2,1);
  mymalloc(select->rs,n/RRR+2,1);
  r = 0;
  for (i=0; i<n; i+=RR) {
    select->rl[i/RR] = r;
    m = 0;
    for (j=0; j<RR; j++) {
      if (j % RRR == 0) {
	select->rs[(i+j)/RRR] = m;
      }
      if (i+j < n && getbit(buf,i+j)==1) m++;
    }
    r += m;
  }
  
}

int selectd_rank(selectd *select, int i)
{
  int r,j;
  pb *p;
  r = select->rl[i>>logRR] + select->rs[i>>logRRR];
  p = select->buf + ((i>>logRRR)<<(logRRR-logD));
  j = i & (RRR-1);
  if (j < D) r += popcount(*p >> (D-1-j));
  else r += popcount(*p) + popcount(p[1] >> (D-1-(j-D)));
  return r;
}


int selectd_select(selectd *select, int i,int f)
{
  int m;
  //  dword *s;
  int p,r;
  int il;
  int rr;
  pb x;
  pb *q;

  if (i == 0) return -1;

#if 0
  if (i > select->m) {
    printf("ERROR: m=%d i=%d\n",select->m,i);
    exit(1);
  }
#endif

  i--;

  il = select->p[i>>logL];
  if (il < 0) {
    il = -il-1;
    p = select->sl[(il<<logL)+(i & (L-1))];
  } else {
    p = select->lp[i>>logL];
    p += select->ss[(il<<(logL-logLLL))+(i & (L-1))/LLL];
    r = i - (i & (LLL-1));

    q = &(select->buf[p>>logD]);

    if (f == 1) {
      rr = p & (D-1);
      r -= popcount(*q >> (D-1-rr));
      p = p - rr;
      
      while (1) {
	rr = popcount(*q);
	if (r + rr >= i) break;
	r += rr;
	p += D;
	q++;
      }
      
      x = *q;
      while (1) {
	//rr = popcount(x >> (D-8));
	rr = popCount[x >> (D-8)];
	//rr = popcount8(x >> (D-8));
	if (r + rr >= i) break;
	r += rr;
	p += 8;
	x <<= 8;
      }
      p += selecttbl[((i-r-1)<<8)+(x>>(D-8))];
    } else {
      rr = p & (D-1);
      r -= popcount((~(*q))  >> (D-1-rr));
      p = p - rr;
      
      while (1) {
	rr = popcount(~(*q));
	if (r + rr >= i) break;
	r += rr;
	p += D;
	q++;
      }
      
      x = ~(*q);

      while (1) {
	//rr = popcount(x >> (D-8));
	rr = popCount[x >> (D-8)];
	//rr = popcount8(x >> (D-8));
	if (r + rr >= i) break;
	r += rr;
	p += 8;
	x <<= 8;
      }
      p += selecttbl[((i-r-1)<<8)+(x>>(D-8))];
    }
  }
  return p;
}

#if 1

#define N 10485760

int main(int argc, char *argv[])
{
  selectd s1;

  int i,r,n,rr, setCount = 0;
  unsigned int hoge;
  FILE *infp = NULL;

  pb *B;
  byte *B2;
  dword *S,*R;

  double t;
  mytimestruct before,after;

  srand(2);

  n = N;
  r = 2;
	if (argc >= 1){
		r=0;
		printf("piep");
		infp = fopen(argv[1],"rb");
		if (infp == NULL){
			printf("can not open %s\n",argv[1]);
			return -1;
		}
		fseek (infp,0,SEEK_END);
		n = ftell(infp);
		rewind(infp);
	}
  else if (argc >= 2){
    r = atoi(argv[1]);
    if (r == 0) {
      infp = fopen(argv[2],"rb");
      if (infp == NULL){
	printf("cannot open %s\n",argv[2]);
	return -1;
      }
      fseek(infp,0,SEEK_END);
      n = ftell(infp);
      rewind(infp);
      //printf("n: %d\n",n);
    } else if (argc >= 3) {
      n = atoi(argv[2]);
    }
  }
  rr = r;

  mymalloc(B,(n+PBS-1+P)/PBS,0);
  //mymalloc(B2,(n+8-1+P)/8,0);
  mymalloc(S,n+1,0);
  mymalloc(R,n+1,0);

  for (i = 0; i < n; i++) {
    setbit(B,i,0);
  }
  if (!infp) {
    for (i = 0; i < n; i++) {
      if (rand() % 100 < r) setbit(B,i,1);
    }
  } else {
    for (i = 0; i < n; i++){
      int c = fgetc(infp);
      if (c == EOF){
	printf("unexpected error at reading from %s\n",argv[2]);
	return -1;
      }
      if (c == '1'){
	setbit(B,i,1);
		setCount++;
      }
      else if (c != '0'){
	printf("unexpected error (2) at reading from %s\n",argv[2]);
	return -1;
      }
    }
  }

  selectd_construct(&s1,n,B);
  printf("used memory: %d bytes (%lf bpc)\n",msize,(double)msize*8/n);

#if 1
  r = 0;
  S[r] = -1;
  for (i=0; i<n; i++) {
    if (getbit(B,i)) {
      r++;
      S[r] = i;
    }
    R[i] = r;
  }
#endif
{	unsigned int POSITIONS = 10000000;
	unsigned int REPEATS = 10;
	unsigned int * const position = (unsigned int *)calloc( POSITIONS, sizeof *position );

	long long i;
	for(i = 0; i < POSITIONS; i++ ) position[ i ] = rand() % n;
	unsigned int dummy = 0x12345678;
	clock_t start = clock();printf ("start\n"); fflush(stdout);
	int k;
	for(k = REPEATS; k-- != 0; )
		for(i = 0; i < POSITIONS; i += 10 ) {
			dummy += selectd_rank(&s1,position[i]);
			dummy += selectd_rank(&s1,position[i + 1]);
			dummy += selectd_rank(&s1,position[i + 2]);
			dummy += selectd_rank(&s1,position[i + 3]);
			dummy += selectd_rank(&s1,position[i + 4]);
			dummy += selectd_rank(&s1,position[i + 5]);
			dummy += selectd_rank(&s1,position[i + 6]);
			dummy += selectd_rank(&s1,position[i + 7]);
			dummy += selectd_rank(&s1,position[i + 8]);
			dummy += selectd_rank(&s1,position[i + 9]);
		}

	clock_t end = clock();printf("end\n"); fflush(stdout);
	float s = (float)(end - start) / CLOCKS_PER_SEC;
//	printf( "%f s, %f ranks/s, %f ns/rank\n", s, (float)(REPEATS * POSITIONS) / s, ((float)(1E9 * s)) / (float)(REPEATS * POSITIONS) );fflush(stdout);
	printf( "%fs, %f ranks/s, hrg%fns/rank, r3j%f \n", s, (double)(REPEATS * POSITIONS) / s, ((double)(1E9 * s)) / (double)(REPEATS * POSITIONS), (double) (msize*8) / n );fflush(stdout);

	printf("\n%d\n", dummy);
/*	for(i = POSITIONS; i-- != POSITIONS; ) position[ i ] = rand() % setCount;
	dummy = 0x12345678;
	start = clock();
	for(k = REPEATS; k-- != 0; )
		for(i = 0; i < POSITIONS; i += 10 ) {
			dummy ^= selectd_select(&s1,position[i],1);
			dummy ^= selectd_select(&s1,position[i+1],1);
			dummy ^= selectd_select(&s1,position[i+2],1);
			dummy ^= selectd_select(&s1,position[i+3],1);
			dummy ^= selectd_select(&s1,position[i+4],1);
			dummy ^= selectd_select(&s1,position[i+5],1);
			dummy ^= selectd_select(&s1,position[i+6],1);
			dummy ^= selectd_select(&s1,position[i+7],1);
			dummy ^= selectd_select(&s1,position[i+8],1);
			dummy ^= selectd_select(&s1,position[i+9],1);
		}

	end = clock();
	s = (float)(end - start) / CLOCKS_PER_SEC;
//	printf( "%f s, %f selects/s, %f ns/select\n", s, (float)(REPEATS * POSITIONS) / s, ((float)(1E9 * s)) / (float)(REPEATS * POSITIONS) );
	printf( "%fs, %f selects/s, hsg%fns/select, s3j%f \n", s, (double)(REPEATS * POSITIONS) / s, ((double)(1E9 * s)) / (double)(REPEATS * POSITIONS),(double) (msize*8)/n );
	if (dummy == 42) printf("22");*/
}
#if 0
  mygettime(&before);
  hoge = rand();
  for (i = 0; i < 100000000; i++) {
    int j;
    //j = (rand() % r)+1;
#ifdef RANDOM
    j = hoge % r + 1;
#else
    j = i % r + 1;
#endif
#ifdef CHECK
    if (selectd_select(&s1,j,1) != S[j]) {
      printf("ERROR: S[%d] = %d, s = %d\n",j,S[j],selectd_select(&s1,j,1));
    }
#else
    selectd_select(&s1,j,1);
#endif

    hoge = hoge * 1566083941U + 1;
  }
  mygettime(&after);
  t = mylaptime(&before,&after);
  printf("%d %f sadad select time\n",rr,t);
#endif

#if 0
  mygettime(&before);
  hoge = rand();
int dummy = 0;
  for (i = 0; i < 100000000; i++) {
    int j;
    //j = (rand() % n);
#ifdef RANDOM
    j = hoge % n;
#else
    j = i % n;
#endif
#ifdef CHECK
    if (selectd_rank(&s1,j) != R[j]) {
      printf("ERROR: (%d) R[%d] = %d, r = %d\n",getbit(B,i),j,R[j],selectd_rank(&s1,j));
    }
#else
    dummy += selectd_rank(&s1,j);
#endif
    hoge = hoge * 1566083941U + 1;
    //selects_rank(&s2,j);
  }
  mygettime(&after);
  t = mylaptime(&before,&after);
  printf("%d %f sadad rank time\n",rr,t);
  printf("%d", dummy);
#endif

  return 0;
}

#endif
