#include <sdsl/vectors.hpp>
#include <iostream>
#include <ctime>
#include <stdio.h>
#include <cstdlib>
#include <cmath>

#include <RSDicBuilder.hpp>
#include <RSDic.hpp>


int main(int argc, char* argv[]){
	FILE* infp = NULL;
	infp = fopen(argv[1],"rb");
	if (infp == NULL){
		printf("cannot open %s\n",argv[1]);
		return -1;
	}
	fseek(infp,0,SEEK_END);
	unsigned int n = ftell(infp);
	rewind(infp);

	rsdic::RSDicBuilder rsdb;

	uint setCount = 0;
	for (uint i = 0; i < n; i++){
		int c = fgetc(infp);
		if (c == EOF){
			printf("unexpected error at reading from %s\n",argv[1]);
			return -1;
		}
		if (c == '1'){
			rsdb.PushBack(1);
			setCount++;
		}
		else if (c == '0'){
			rsdb.PushBack(0);
		}
		else {
			printf("unexpected error (2) at reading from %s\n",argv[1]);
			return -1;
		}
	}
	rsdic::RSDic BSRRR;
	rsdb.Build(BSRRR);

	printf("size in Bits is %d\n", BSRRR.GetUsageBytes()*8);

	unsigned int POSITIONS = 1000000;
	unsigned int REPEATS = 10;
	unsigned int * const position = (unsigned int *)calloc( POSITIONS, sizeof *position );


	for(  long long i = 0; i < POSITIONS; i++ ) position[ i ] = rand() % n;
	unsigned int dummy = 0x12345678;
	sdsl::stop_watch* stoppie = new sdsl::stop_watch();
	stoppie->start();	

	
	for( int k = REPEATS; k-- != 0; )
		for( int i = 0; i < POSITIONS; i += 10 ) {
			dummy ^= BSRRR.Rank( position[ i ], 1 );
			dummy ^= BSRRR.Rank( position[ i + 1 ],1 );
			dummy ^= BSRRR.Rank( position[ i + 2 ],1 );
			dummy ^= BSRRR.Rank( position[ i + 3 ],1 );
			dummy ^= BSRRR.Rank( position[ i + 4 ],1 );
			dummy ^= BSRRR.Rank( position[ i + 5 ],1 );
			dummy ^= BSRRR.Rank( position[ i + 6 ],1 );
			dummy ^= BSRRR.Rank( position[ i + 7 ],1 );
			dummy ^= BSRRR.Rank( position[ i + 8 ],1 );
			dummy ^= BSRRR.Rank( position[ i + 9 ],1 );
		}

	stoppie->stop();
	double s = stoppie->get_user_time() / 1000;
	printf( "%fs, %f ranks/s, hrg%fns/rank, r3j%f \n", s, (double)(REPEATS * POSITIONS) / s, ((double)(1E9 * s)) / (double)(REPEATS * POSITIONS), (double)BSRRR.GetUsageBytes()*8 / n );fflush(stdout);
	printf( "%d\n", dummy);
/*	float s = (float)(end - start) / CLOCKS_PER_SEC;
	printf( "%f s, %f ranks/s, %f ns/rank\n", s, (float)(REPEATS * POSITIONS) / s, ((float)(1E9 * s)) / (float)(REPEATS * POSITIONS) );fflush(stdout);
	printf( "%d\n", dummy);*/

	for(  long long i = 0; i < POSITIONS; i++ ) position[ i ] = rand() % setCount;
	dummy = 0x12345678;
	stoppie->start();
//	start = clock();
	
	for( int k = REPEATS; k-- != 0; )
		for( int i = 0; i < POSITIONS; i += 10 ) {
			dummy ^= BSRRR.Select( position[ i ],1 );
			dummy ^= BSRRR.Select( position[ i + 1 ],1 );
			dummy ^= BSRRR.Select( position[ i + 2 ],1 );
			dummy ^= BSRRR.Select( position[ i + 3 ],1 );
			dummy ^= BSRRR.Select( position[ i + 4 ],1 );
			dummy ^= BSRRR.Select( position[ i + 5 ],1 );
			dummy ^= BSRRR.Select( position[ i + 6 ],1 );
			dummy ^= BSRRR.Select( position[ i + 7 ],1 );
			dummy ^= BSRRR.Select( position[ i + 8 ],1 );
			dummy ^= BSRRR.Select( position[ i + 9 ],1 );
		}

//	end = clock();
	stoppie->stop();
	s = stoppie->get_user_time() / 1000;
//	s = (float)(end - start) / CLOCKS_PER_SEC;
	printf( "%fs, %f selects/s, hsg%fns/select, s3j%f \n", s, (float)(REPEATS * POSITIONS) / s, ((float)(1E9 * s)) / (float)(REPEATS * POSITIONS) );
	printf( "%d\n", dummy);
	if (dummy == 42) printf("22");



	return 0;
}
