#define INTSIZE 32
#define ENUINTSIZEDECTBL 65536

#include <stdio.h>
#include "common.hpp"
#define USEDECODETABLE

class comb{

public:
	comb(uint _size): size(_size), nCk(NULL){
		nCk  = new uint* [size+1];
		for (uint i = 0; i <= size; i++){
			nCk[i] = new uint [size+1];
		}

		for (uint i = 0; i <= size; i++) for (uint j = 0; j <= size; j++) { nCk[i][j] = 0;}
		for (uint i = 0; i <= size; i++) nCk[0][i] = 1;
		for (uint i = 0; i <= size; i++) nCk[i][i] = 1;
		for (uint j = 1; j <= size; j++) {
			for (uint i = 1; i < j; i++){
				if (nCk[i-1][j-1] > 0 && nCk[i][j-1] > 0){
					nCk[i][j] = nCk[i-1][j-1] + nCk[i][j-1];
				}
			}
		}

		for (uint i=0; i<=INTSIZE; i++) {
			if (nCk[i][INTSIZE]>0 && nCk[i][INTSIZE] <= ENUINTSIZEDECTBL) {
				nCkDec[i] = new uint[nCk[i][INTSIZE]];
				for (uint t = 0; t < nCk[i][INTSIZE]; t++){
					nCkDec[i][t] = _enumDecode(i,INTSIZE,t);
				}
			}
			else {
				nCkDec[i] = NULL;
			}
		}
	}

private:
	uint _enumDecode(uint oneNum, uint num, uint x) const{
		uint bits = 0;
		for (uint k = 0; k < num; k++) {
			if (x >= nCk[oneNum][num-k-1]){
				x -= nCk[oneNum][num-k-1];
				if (oneNum == 0){
				  //fprintf(stderr,"enumDecode error one:%d num:%d x:%d\n",oneNum,num,x);
					return 0;
				}
				oneNum--;
				bits |=  (1U << (INTSIZE - 1 - k)); //32 should be replaced
			}
		}
		return bits;
	}

public:
	uint enumDecode(uint oneNum, uint num, uint x) const{
	  #ifdef USEDECODETABLE
		if (nCkDec[oneNum] != NULL){
			return nCkDec[oneNum][x];
		}
	  #endif //USEDECODETABLE
		return _enumDecode(oneNum,num,x);
	}


	~comb(){
		if (nCk) {
			for (uint i = 0; i < size; i++) delete[] nCk[i];
			delete[] nCk;
		}

		for (uint i = 0; i <= INTSIZE; i++){
			if (nCkDec[i] != NULL) delete[] nCkDec[i];
		}
	}

	uint choose(uint n, uint k) const{
		return nCk[n][k];
	}

private:
	uint** nCk;
	uint* nCkDec[INTSIZE+1];
	uint size;

};
