#ifndef __PACKED_BV_HPP__
#define __PACKED_BV_HPP__

#include "common.hpp"
#include "bitVector.hpp"

class packedBV{
public:
	packedBV():packSize(0){}
	packedBV(uint* s, uint n):packSize(0){ build(s,n); }

	~packedBV() {
	
	}

	void build(uint* s, uint n){
		uint maxS = 0;
		for (uint i = 0; i < n; i++){
			if (s[i] > maxS){
				maxS = s[i];
			}
		}
		packSize = lg(maxS);
		bv.resize(packSize*n);
		for (uint i = 0; i < n; i++){
			bv.setBits(i*packSize,packSize,s[i]);
		}
	}

	uint getSize() const{
		return bv.getSize();
	}
	
	uint operator [](const uint x) const{
		return bv.getBits(x*packSize,packSize);
	}

	uint getPackSize() const{
		return packSize;
	}
private:
	bitVector bv;
	uint packSize;
};

#endif
