#include <stdio.h>
#include <fstream>
#include <iostream>
#include <sstream>
#include <cmath>
#include <vector>
using namespace std;

int main( int argc, const char* argv[] )
{
	ifstream infile;
	infile.open(argv[1]);
	unsigned int entropyOrder;
	string str(argv[2]);
	stringstream ss(str);
	ss >> entropyOrder;
	unsigned int mask = (1 << entropyOrder) - 1;

	//determine encodings for bits
	char zero = infile.get();
	char one = 0;
	char c;
	while(!one) {
		c = infile.get();
		if (zero != c) one = c;
	}
	infile.seekg (0, ios::beg);

	vector<pair<unsigned int, unsigned int> > count;
	count.resize (1 << entropyOrder);
	unsigned int lastBits = 0;
	for (unsigned int i = 0; i < entropyOrder; i++) {
		c = infile.get();
		if (c == one) lastBits = ((lastBits << 1) | 1) & mask;
		else lastBits = (lastBits << 1) & mask;
	}
	unsigned int n = 0;		// n = entropyOrder, if you want to count the first k bits
	while (infile.good()) {
		n++;
		c = infile.get();
		if (c == one) {
			((count[lastBits]).first)++;
			lastBits = ((lastBits << 1) | 1) & mask;
		}
		else {
			((count[lastBits]).second)++;
			lastBits = (lastBits << 1) & mask;
		}
		
	}
	double entropy = 0;
	double ones, zeros, total;
	for (vector<pair<unsigned int, unsigned int> >::iterator countIter = count.begin(); countIter != count.end(); countIter++){
		ones = (*countIter).first;
		zeros = (*countIter).second;
		total = ones + zeros;
		if (zeros != 0  && ones != 0) entropy += (total / n) * (ones / total * (log(total / ones)/log(2)) + zeros / total * (log (total / zeros)/log(2)));
	}
//	char c = infile.get();		
	printf("empirical entropy of order %d is %f\n", entropyOrder, entropy);

	return 0;
}
