#include <stdio.h>
#include <fstream>
#include <iostream>
#include <cstdlib>
#include <ctime>
#include <string>
#include <sstream>
#include <vector>

#define MaxProb 100	//1/ MaxProb is the maximum probability that may occur in the table
unsigned int Bits;
#define BitMask ((1 << Bits) - 1)
using namespace std;

string int2string(const int& number)
{
	ostringstream oss;
	oss << number;
	return oss.str();
}


int main( int argc, const char* argv[] )
{
	int seed = time(0);
	srand(seed);
	string filename(argv[1]);
	filename += int2string(seed);
	filename += ".txt";
	ofstream outf(filename.c_str());

	unsigned int fileLength;
	string str(argv[2]);
	stringstream ss(str);
	ss >> fileLength;
	if (ss.fail()) printf("error1");
	// If we couldn't open the output file stream for writing
	if (!outf)
	{
		// Print an error and exit
		cerr << "Uh oh, " << argv[1] << " could not be opened for writing!" << endl;
//		exit(1);
	}
	string str2(argv[3]);
	stringstream ss2(str2);
	ss2 >> Bits;
	printf("\nBits: %d\n", Bits);fflush(stdout);
	vector<int> probabilities;
	probabilities.resize(1 << Bits);
	printf("RAND_MAX = %d\n", RAND_MAX);
/*
	for(vector<int>::iterator iter = probabilities.begin(); iter != probabilities.end(); iter++) {
		unsigned int rnd = rand();
		if (RAND_MAX/50 < rnd && rnd < RAND_MAX/2) *iter = rnd % (RAND_MAX/50);
		else if (RAND_MAX/2 < rnd && rnd < RAND_MAX - (RAND_MAX/50)) *iter =  RAND_MAX - (rnd% (RAND_MAX/50));
		else *iter = rnd;
//		*iter = rand();
		printf("%4f ",((double) *iter)/((double)RAND_MAX));
	}*/

	for (unsigned int i = 0; i < (1<<(Bits-1)); i++) {
		unsigned int rnd = rand();
		if (rnd < RAND_MAX/2) {
			probabilities[i] = rnd % (RAND_MAX/MaxProb);
			probabilities[i + (1<<(Bits-1))] = RAND_MAX - (rnd % (RAND_MAX/MaxProb));
		}
		else {
			probabilities[i] =  RAND_MAX - (rnd% (RAND_MAX/MaxProb));
			probabilities[i + (1<<(Bits-1))] = (rnd% (RAND_MAX/MaxProb));
		}
//		*iter = rand();
		printf("%4f ",((double) probabilities[i])/((double)RAND_MAX));
	}



	unsigned int lastbits = 0;
	
	//first virtual bits are calculated with uniform probability, those bits are not part of the output
	for (unsigned int i = 0; i < Bits; i++) {
		if (rand() < (RAND_MAX / 2)) {
			lastbits = ((lastbits << 1) | 1 ) &BitMask;
		}
		else {
			lastbits = (lastbits << 1) & BitMask;
		}
	}
	printf("lastbits = %x", lastbits);
	for (unsigned int i = 0; i < fileLength; i++) {
		if (rand() < probabilities[lastbits]) {
			lastbits = ((lastbits << 1) | 1 ) &BitMask;
			outf.put('1');
		}
		else {
			lastbits = (lastbits << 1) & BitMask;
			outf.put('0');
		}
	}

	outf.close();
	





} 
